<?php
/**
 * @package		Joomla.Plugin
 * @subpackage	System.Jblibrary
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2012 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		2.0.1
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Form Field class to inject Javascript into JBLibrary Plugin admin form.
 *
 * @since		1.6
 */

class JFormFieldConfigscripts extends JFormField
{
	protected   $type = 'Configscripts';

	protected function getInput()
	{
		$doc = JFactory::getDocument();
		$app = JFactory::getApplication();

		$pluginMediaPath = (string) JURI::root(true) . '/media/plg_jblibrary';

		if (version_compare(JVERSION, '3.0', '<'))
		{
			$doc->addScript($pluginMediaPath . '/jquery/jquery-1.8.2.min.js');
			$doc->addScript($pluginMediaPath . '/jquery/jquery-noconflict.js');

			$app->set('jquery', true);
		}

		$doc->addScript($pluginMediaPath . '/admin/config-scripts.js');

		return '';
	}

	function fetchTooltip($label, $description, &$node, $control_name, $name)
	{
		// Output
		return '&nbsp;';
	}
}
